=== debian/changelog ===
megaglest (3.7.1-3) unstable; urgency=medium

  * Team upload.
  * Fix building with -DCMAKE_BUILD_TYPE=None (Closes: #739068)

 -- Paul Wise <pabs@debian.org>  Wed, 26 Mar 2014 10:54:58 +0800

megaglest (3.7.1-2.1) unstable; urgency=low

  * Non-maintainer upload.
  * Update xerces build dependency to libxerces-c-dev. (Closes: #733074)

 -- Jay Berkenbilt <qjb@debian.org>  Wed, 15 Jan 2014 12:20:12 -0500

megaglest (3.7.1-2) unstable; urgency=low

  * Team upload.
  * Fix the architecture list of megaglest-dbg package (Closes: #725055)

 -- Paul Wise <pabs@debian.org>  Tue, 22 Oct 2013 19:01:38 +0800

megaglest (3.7.1-1) unstable; urgency=low

  [ Mark Vejvoda ]
  * New upstream release (Closes: #703273) (LP: #1216684)
    - Fixes upstream reported defects
    - Fixes FTBFS on non-x86 architectures (Closes: #654283)
    - Fixes graphics issues (Closes: #534213)
    - Upstream added vlc dependencies, add to deps/build-deps
    - Upstream dropped the configurator, don't install it
    - Drop patch that was included upstream
  * Bump Standards-Version
  * Update copyright information
  * Let upstream code autodetect the miniupnpc version

  [ Eddy Petrișor ]
  * Remove myself from Uploaders

  [ Paul Wise ]
  * Upstream switched away from luajit, change build-deps
  * wrap-and-sort -s
  * Copyright file is not well-formed, don't claim it is
  * Bump to debhelper compat 9
  * Drop glest transitional package
  * Fix the Vcs-Browser header
  * Override a lintian warning about substvars, upstream syncs versions

  [ Evgeni Golov ]
  * Correct Vcs-* URLs to point to anonscm.debian.org

 -- Mark Vejvoda <mark_vejvoda@hotmail.com>  Wed, 18 Sep 2013 21:01:59 +0200
