=== debian/watch ===
version=3
http://sf.net/megaglest/megaglest-source-([\d.]+)\.(?:zip|tar\.gz|tar\.bz2|tar\.xz)
